"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateHelpers = void 0;
const fs_1 = require("fs");
const path_1 = __importDefault(require("path"));
const prettier_1 = require("prettier");
const helpersTemplate = `
/* eslint-disable */
export interface Decoder<T> {
  definitionName: string;
  schemaRef: string;
  decode: (json: unknown) => T;
}
`;
function generateHelpers(prettierOptions, outDirs) {
    const helpers = (0, prettier_1.format)(helpersTemplate, prettierOptions);
    outDirs.forEach(outDir => {
        (0, fs_1.mkdirSync)(outDir, { recursive: true });
        (0, fs_1.writeFileSync)(path_1.default.join(outDir, `helpers.ts`), helpers);
    });
}
exports.generateHelpers = generateHelpers;
