import { RouteInfo } from '../parse-controller-schema';
import { GeneratorOptions, HTTPMethod } from '../utils';
import { ImportsGenerator } from './imports';
interface MethodInfo {
    reqSchemaName: string;
    resTypeName: string;
    decorators: {
        [key in HTTPMethod]?: {
            url: string;
            schemaName: string;
            options: Record<string, string>;
        };
    };
}
export type ControllerCode = {
    inClassBody: string;
    imports: ImportsGenerator;
    methods: Record<string, MethodInfo>;
};
export declare function generateControllers(options: GeneratorOptions, schema: Map<string, RouteInfo[]>): Promise<Map<string, ControllerCode>>;
export {};
//# sourceMappingURL=controller.d.ts.map