"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImportsGenerator = void 0;
class ImportsGenerator {
    map = new Map;
    asMap() {
        return this.map;
    }
    asRecord() {
        return Object.fromEntries(this.map.entries());
    }
    addImport(from, field) {
        if (!this.map.has(from))
            this.map.set(from, []);
        if (this.map.get(from).includes(field))
            return;
        this.map.get(from).push(field);
    }
    generate() {
        const lines = [];
        const fromNames = [...this.map.keys()];
        fromNames.forEach((fromName) => {
            const imports = this.map.get(fromName);
            lines.push(`import { ${imports.join(', ')} } from '${fromName}';`);
        });
        return lines.join("\n");
    }
}
exports.ImportsGenerator = ImportsGenerator;
