"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSchema = void 0;
// import toJsonSchema from '@openapi-contrib/openapi-schema-to-json-schema';
// import { readFile } from 'fs/promises';
// import jsYaml from 'js-yaml';
// import { JSONSchema } from 'json-schema-to-typescript';
// export type SchemaType = 'yaml' | 'json' | 'custom';
// export interface ParsedSchema {
//     json: string;
//     definitions: Record<string, JSONSchema>;
//     whitelistedDecoders: string[] | undefined;
// }
// async function parseOpenApiSchema(inputFilePath: string, schemaType: 'yaml' | 'json'): Promise<ParsedSchema> {
//     let schema: any;
//     const inputFileContent = await readFile(inputFilePath, 'utf8');
//     if (schemaType === 'yaml') {
//         schema = jsYaml.load(inputFileContent);
//     } else {
//         schema = JSON.parse(inputFileContent);
//     }
//     const properties: Record<string, any> = {};
//     const definitions: Record<string, JSONSchema> = {};
//     Object.entries(schema.components.schemas).forEach(([key, value]) => {
//         properties[key] = { $ref: `#/definitions/${key}` };
//         definitions[key] = toJsonSchema(value as Record<string, any>);
//     });
//     // open api is a bit different so we need to creata a different schema
//     const schemaJsonOutput = JSON.stringify(
//         {
//             type: 'object',
//             title: 'Schema',
//             definitions,
//             properties,
//         },
//         undefined,
//         2
//     ).replace(/#\/components\/schemas/g, '#/definitions');
//     return {
//         json: schemaJsonOutput,
//         definitions,
//         whitelistedDecoders: undefined,
//     };
// }
// function parseCustomSchema(inputFilePath: string): ParsedSchema {
//     // eslint-disable-next-line import/no-dynamic-require, global-require
//     const schema = require(inputFilePath);
//     if (typeof schema.types !== 'object') {
//         throw new Error('schema "types" should be an object');
//     }
//     const properties: Record<string, any> = {};
//     const definitions: Record<string, any> = {};
//     Object.entries(schema.types).forEach(([key, value]) => {
//         properties[key] = { $ref: `#/definitions/${key}` };
//         definitions[key] = value;
//     });
//     const schemaJsonOutput = JSON.stringify(
//         {
//             type: 'object',
//             title: 'Schema',
//             definitions,
//             properties,
//         },
//         undefined,
//         2
//     );
//     return {
//         json: schemaJsonOutput,
//         definitions,
//         whitelistedDecoders: schema.decoders,
//     };
// }
// export async function parseSchema(inputFilePath: string, schemaType: SchemaType): Promise<ParsedSchema> {
//     switch (schemaType) {
//         case 'json':
//         case 'yaml':
//             return parseOpenApiSchema(inputFilePath, schemaType);
//         case 'custom':
//             return Promise.resolve(parseCustomSchema(inputFilePath));
//         default: {
//             throw new Error(`Unknown schema type: ${schemaType}`);
//         }
//     }
// }
const json_schema_ref_parser_1 = __importDefault(require("@apidevtools/json-schema-ref-parser"));
const promises_1 = require("fs/promises");
const js_yaml_1 = __importDefault(require("js-yaml"));
const path_1 = __importDefault(require("path"));
const utils_1 = require("./utils");
async function parseSchema(pathToIndex) {
    const indexSchemaContent = await (0, promises_1.readFile)(pathToIndex, 'utf-8');
    const indexSchema = js_yaml_1.default.loadAll(indexSchemaContent);
    const fullSchemaArr = (await json_schema_ref_parser_1.default.dereference(indexSchema, {
        continueOnError: false,
        parse: {
            json: false,
            yaml: {
                allowEmpty: false,
            },
        },
        resolve: {
            file: {
                read: async (file, cb) => {
                    if (file.url.includes('json-schema-ref-parser/dist/')) {
                        const realPath = (0, utils_1.resolvePath)(file.url.split('json-schema-ref-parser/dist/')[1], path_1.default.dirname(pathToIndex));
                        const res = await (0, promises_1.readFile)(realPath, 'utf-8');
                        cb(undefined, res);
                        return res;
                    }
                    const res = (0, promises_1.readFile)(file.url, 'utf-8');
                    cb(undefined, res);
                    return res;
                },
            },
        },
        dereference: {
        // circular: true,
        },
    }));
    return fullSchemaArr[0];
}
exports.parseSchema = parseSchema;
