"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSchema = void 0;
const json_schema_ref_parser_1 = __importDefault(require("@apidevtools/json-schema-ref-parser"));
const promises_1 = require("fs/promises");
const js_yaml_1 = __importDefault(require("js-yaml"));
const path_1 = __importDefault(require("path"));
const utils_1 = require("./utils");
async function parseSchema(pathToIndex) {
    const indexSchemaContent = await (0, promises_1.readFile)(pathToIndex, 'utf-8');
    const indexSchema = js_yaml_1.default.loadAll(indexSchemaContent);
    const fullSchemaArr = (await json_schema_ref_parser_1.default.dereference(indexSchema, {
        continueOnError: false,
        parse: {
            json: false,
            yaml: {
                allowEmpty: false,
            },
        },
        resolve: {
            file: {
                read: async (file, cb) => {
                    if (file.url.includes('json-schema-ref-parser/dist/')) {
                        const realPath = (0, utils_1.resolvePath)(file.url.split('json-schema-ref-parser/dist/')[1], path_1.default.dirname(pathToIndex));
                        const res = await (0, promises_1.readFile)(realPath, 'utf-8');
                        cb(undefined, res);
                        return res;
                    }
                    const res = (0, promises_1.readFile)(file.url, 'utf-8');
                    cb(undefined, res);
                    return res;
                },
            },
        },
        dereference: {
        // circular: true,
        },
    }));
    return fullSchemaArr[0];
}
exports.parseSchema = parseSchema;
