import { JSONSchema } from 'json-schema-to-typescript';
import type { OpenAPIV3 } from 'openapi-types';
export interface RouteSchema {
    body?: JSONSchema;
    querystring: JSONSchema;
    params: JSONSchema;
    headers?: JSONSchema;
    response?: JSONSchema | Record<string | number, {
        description: string;
        content: Record<string | number, any>;
    }>;
}
export interface RouteInfo {
    summary?: string;
    url: string;
    method: 'GET' | 'POST' | 'PATCH' | 'PUT' | 'DELETE';
    schema: RouteSchema;
    group: string;
}
export declare function pathsToControllersRoutes(schema: OpenAPIV3.Document): Promise<Map<string, RouteInfo[]>>;
//# sourceMappingURL=paths-to-controllers-routes.d.ts.map