import { HTTPMethod } from '../utils';
export interface ControllerDesiredData {
    className: string;
    imports: Record<string, string[]>;
    methods: Record<string, {
        reqSchemaName: string;
        resTypeName: string;
        decorators: {
            [key in HTTPMethod]?: {
                url: string;
                schemaName: string;
                options: Record<string, string>;
            };
        };
    }>;
}
/**
 *
 * @param code
 * @param desiredData
 * @example const desiredData: DesiredData = {
    className: 'AuthController',
    imports: {},
    methods: {
        loginHandler: {
            reqSchemaName: 'LoginSchemaType',
            resTypeName: 'FastifyReply',
            decorators: {
                POST: {
                    url: '/login',
                    schemaName: 'LoginSchema',
                    options: {
                        bodyLimit: '1024 * 1024 * 8',
                    },
                },
            },
        },
        logoutHandler: {
            reqSchemaName: 'LogoutSchemaType',
            resTypeName: 'FastifyReply',
            decorators: {
                GET: {
                    url: '/logout',
                    schemaName: 'LogoutSchema',
                    options: {},
                },
            },
        },
    },
};
 */
export declare function transformController(code: string, desiredData: ControllerDesiredData): string;
//# sourceMappingURL=controller.d.ts.map